-- Memory Cleaner by MikuAuahDark

-- User Configuration
CleanTimes=5	-- Do memory clean every x times(default 5)
TimeToClean=300	-- Do memory clean only every x seconds(default 5 minutes, 300 seconds)
ShowMsg=true	-- Show message when start cleaning
NormHook=true	-- Always use normal hooking method even if Improved addhook LUA is exist(true by default because it little faster)
-- End of user configuration. It's your risk to edit code below

if NormHook then
	(((ah2 or nil) and ah2.original_addhook) or addhook)("second","MemoryCleaner")
else
	addhook("second","MemoryCleaner")
end
function MemoryCleaner()
	if os.time()%TimeToClean==0 then
		if ShowMsg==true then
			print("Performing memory cleaner, clean every "..CleanTimes.." time(s)")
			for i=1,CleanTimes do
				local before=math.floor(collectgarbage("count"))
				collectgarbage("collect")
				print("Clean "..i.." complete, "..(before-math.floor(collectgarbage("count"))).."Kbytes cleaned!")
			end
		else
			for i=1,CleanTimes do
				collectgarbage("collect")
			end
		end
	end
end